VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsDialogBox"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

' No Error handler was implemented here as this
' can be used as a DLL or Class EXE file.
' Written By Scott Woods for Woolworths QLD

'API function declaration
Private Type OPENFILENAME
    lStructSize         As Long
    hwndOwner           As Long
    hInstance           As Long
    lpstrFilter         As String
    lpstrCustomFilter   As String
    nMaxCustFilter      As Long
    nFilterIndex        As Long
    lpstrFile           As String
    nMaxFile            As Long
    lpstrFileTitle      As String
    nMaxFileTitle       As Long
    lpstrInitialDir     As String
    lpstrTitle          As String
    flags               As Long
    nFileOffset         As Integer
    nFileExtension      As Integer
    lpstrDefExt         As String
    lCustData           As Long
    lpfnHook            As Long
    lpTemplateName      As String
End Type

Private Type BrowseInfo
     hwndOwner      As Long
     pIDLRoot       As Long
     pszDisplayName As Long
     lpszTitle      As Long
     ulFlags        As Long
     lpfnCallback   As Long
     lParam         As Long
     iImage         As Long
End Type

'DLL function declarations
Private Declare Function GetOpenFileName Lib "comdlg32.dll" Alias _
    "GetOpenFileNameA" (pOpenfilename As OPENFILENAME) As Long

Private Declare Function GetSaveFileName Lib "comdlg32.dll" Alias _
    "GetSaveFileNameA" (pOpenfilename As OPENFILENAME) As Long

Private Declare Sub CoTaskMemFree Lib "ole32.dll" (ByVal hMem As Long)
Private Declare Function lstrcat Lib "Kernel32" Alias "lstrcatA" _
     (ByVal lpString1 As String, ByVal lpString2 As String) As Long
Private Declare Function SHBrowseForFolder Lib "shell32" _
     (lpbi As BrowseInfo) As Long
Private Declare Function SHGetPathFromIDList Lib "shell32" _
     (ByVal pidList As Long, ByVal lpBuffer As String) As Long

'Module level variable declaration
Private mstrFileName    As String
Private mstrInitDir     As String
Private mstrDialogTitle As String
Private mstrFilter      As String
Private Const BIF_RETURNONLYFSDIRS = 1
Private Const MAX_PATH = 260

Private Sub Class_Initialize()
    mstrFileName = ""
    mstrInitDir = App.Path
    mstrDialogTitle = App.Title
    mstrFilter = "All Files (*.*) " & Chr(0) & "*.*" & Chr(0)
End Sub
Public Function ShowOpen(Optional ByVal lng_FormHwnd As Long, _
                         Optional ByVal str_NewFileName As String, _
                         Optional ByVal str_NewFilter As String, _
                         Optional ByVal str_NewTitle As String) As String
    
    Dim OpenFile As OPENFILENAME
    Dim lngReturn As Long
    Dim strFilter As String
    Dim strFileName As String
    Dim strDialogTitle As String
    Dim intSize As Integer

    If IsMissing(str_NewFilter) Or str_NewFilter = "" Then
        strFilter = mstrFilter
    Else
        strFilter = str_NewFilter
    End If
    If IsMissing(str_NewFileName) Or str_NewFileName = "" Then
        strFileName = mstrFileName
    Else
        strFileName = str_NewFileName
    End If
    If IsMissing(str_NewTitle) Or str_NewTitle = "" Then
        strDialogTitle = mstrDialogTitle
    Else
        strDialogTitle = str_NewTitle
    End If

    intSize = 257 - Len(strFileName)
With OpenFile
        .lStructSize = Len(OpenFile)
        .hInstance = App.hInstance
        .lpstrFilter = strFilter
        .nFilterIndex = 1
        .lpstrFile = strFileName & String(intSize, 0)
        .nMaxFile = Len(OpenFile.lpstrFile) - 1
        .lpstrFileTitle = OpenFile.lpstrFile
        .nMaxFileTitle = OpenFile.nMaxFile
        .lpstrInitialDir = mstrInitDir
        .lpstrTitle = strDialogTitle
        .flags = 0
        .hwndOwner = lng_FormHwnd
    End With
    
    lngReturn = GetOpenFileName(OpenFile)
    If lngReturn = 0 Then
        ShowOpen = ""
    Else
        ShowOpen = CleanFileName(OpenFile.lpstrFile)
        FileName = CleanFileName(OpenFile.lpstrFile)
    End If

End Function

Public Function ShowSave(Optional ByVal lng_FormHwnd As Long, _
                         Optional ByVal str_NewFileName As String, _
                         Optional ByVal str_NewFilter As String, _
                         Optional ByVal str_NewTitle As String) As String

  Dim OpenFile        As OPENFILENAME
  Dim lngReturn       As Long
  Dim strFilter       As String
  Dim strFileName     As String
  Dim strDialogTitle  As String
  Dim intSize         As Integer

    If IsMissing(str_NewFilter) Or str_NewFilter = "" Then
        strFilter = mstrFilter
    Else
        strFilter = str_NewFilter
    End If
    If IsMissing(str_NewFileName) Or str_NewFileName = "" Then
        strFileName = mstrFileName
    Else
        strFileName = str_NewFileName
    End If
    If IsMissing(str_NewTitle) Or str_NewTitle = "" Then
        strDialogTitle = mstrDialogTitle
    Else
        strDialogTitle = str_NewTitle
    End If

    intSize = 257 - Len(strFileName)

With OpenFile
        .lStructSize = Len(OpenFile)
        .hInstance = App.hInstance
        .lpstrFilter = strFilter
        .nFilterIndex = 1
        .lpstrFile = strFileName & String(intSize, 0)
        .nMaxFile = Len(OpenFile.lpstrFile) - 1
        .lpstrFileTitle = OpenFile.lpstrFile
        .nMaxFileTitle = OpenFile.nMaxFile
        .lpstrInitialDir = mstrInitDir
        .lpstrTitle = strDialogTitle
        .flags = 0
        .hwndOwner = lng_FormHwnd
    End With
    
    lngReturn = GetSaveFileName(OpenFile)
    If lngReturn = 0 Then
        ShowSave = ""
    Else
        ShowSave = CleanFileName(OpenFile.lpstrFile)
        FileName = CleanFileName(OpenFile.lpstrFile)
    End If

End Function

Public Property Get FileName() As String
    FileName = mstrFileName
End Property
Public Property Let FileName(ByVal NewValue As String)
    mstrFileName = NewValue
End Property
Public Property Get InitDir() As String
    InitDir = mstrInitDir
End Property
Public Property Let InitDir(ByVal NewValue As String)
    mstrInitDir = NewValue
End Property
Public Property Get DialogTitle() As String
    DialogTitle = mstrDialogTitle
End Property
Public Property Let DialogTitle(ByVal NewValue As String)
    mstrDialogTitle = NewValue
End Property
Public Property Get Filter() As String
    Filter = mstrFilter
End Property
Public Property Let Filter(ByVal NewValue As String)
    mstrFilter = NewValue
End Property
     
Public Function BrowseForFolder(hwndOwner As Long, sPrompt As String) As String

' This function calls the Browse Dialog window
' which shows only folders, no files..

     Dim intNull            As Integer
     Dim lngIDList          As Long
     Dim lngResult          As Long
     Dim strPath            As String
     Dim udtBrowseInfo      As BrowseInfo

     With udtBrowseInfo
          .hwndOwner = hwndOwner
          .lpszTitle = lstrcat(sPrompt, "")
          .ulFlags = BIF_RETURNONLYFSDIRS
     End With

     lngIDList = SHBrowseForFolder(udtBrowseInfo)
     If lngIDList Then
          strPath = String$(MAX_PATH, 0)
          lngResult = SHGetPathFromIDList(lngIDList, strPath)
          Call CoTaskMemFree(lngIDList)
          intNull = InStr(strPath, vbNullChar)
          If intNull Then
               strPath = Left$(strPath, intNull - 1)
          End If
     End If
     BrowseForFolder = strPath
End Function

Private Function CleanFileName(ByVal str_FileName As String) As String

Dim intLoop As Integer

For intLoop = Len(str_FileName) To 1 Step -1
    If Mid(str_FileName, intLoop, 1) <> Chr(0) Then
        CleanFileName = Mid(str_FileName, 1, intLoop)
        Exit For
    End If
Next intLoop

End Function
